<?php
namespace common\helpers;

use Yii;

class Utils
{
    /**
     * 获取一级域名
     * @return mixed|string
     */
    public static function getTopDomain()
    {
        $hostInfo = Yii::$app->getRequest()->getHostInfo();
        $host = parse_url($hostInfo, PHP_URL_HOST);
        $hostArr = explode('.', $host);
        $hostArr = array_reverse($hostArr);
        if (count($hostArr) >= 2) {
            return "{$hostArr[1]}.{$hostArr[0]}";
        } else {
            return $host;
        }
    }

    /**
     * 格式化整数、浮点数
     * @param $number
     * @param int $decimals
     * @return int|string
     */
    public static function formatFloatOrInt($number, $decimals = 2)
    {
        if (!is_numeric($number)) {
            return $number;
        }
        if (intval($number) == $number) {
            return intval($number);
        } else {
            return number_format($number, $decimals, '.', '');
        }
    }

    /**
     * 校验手机号码格式
     * @param string $phone
     * @return bool
     */
    public static function checkPhoneNumber($phone)
    {
        return preg_match('/^1(3[0-9]|4[57]|5[0-35-9]|7[01678]|8[0-9])\d{8}$/', $phone) != false;
    }

    /**
     * 获取客户端IP地址
     * @param integer $type 返回类型 0 返回IP地址 1 返回IPV4地址数字
     * @return mixed
     */
    public static function getClientIp($type = 0)
    {
        $type = $type ? 1 : 0;
        static $ip = NULL;
        if ($ip !== NULL) return $ip[$type];
        if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $arr = explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);
            $pos = array_search('unknown', $arr);
            if (false !== $pos) unset($arr[$pos]);
            $ip = trim($arr[0]);
        } elseif (isset($_SERVER['HTTP_CLIENT_IP'])) {
            $ip = $_SERVER['HTTP_CLIENT_IP'];
        } elseif (isset($_SERVER['REMOTE_ADDR'])) {
            $ip = $_SERVER['REMOTE_ADDR'];
        }
        // IP地址合法验证
        $long = sprintf("%u", ip2long($ip));
        $ip = $long ? array($ip, $long) : array('0.0.0.0', 0);
        return $ip[$type];
    }
}